#Использовать yaml

#Область ОписаниеПеременных

Перем Лог;                      // Объект записи лога приложения
Перем РабочийКаталог;           // Строка - текущий рабочий каталог
Перем КаталогПриложения;        // Строка - текущий каталог приложения

#КонецОбласти

#Область ПрограммныйИнтерфейс

Процедура ВыполнитьКоманду(Знач Команда) Экспорт
	
	Лог = ПараметрыПриложения.Лог();

	ТекущийКаталогSrc   = ОбъединитьПути(ТекущийКаталог(), "src");
	СтартовыйКаталогSrc = СтартовыйСценарий().Каталог;
	Если ТекущийКаталогSrc = СтартовыйКаталогSrc Тогда
		Лог.Ошибка("Невозможно выполнить сценарий в каталоге исходного проекта");
		Возврат;
	КонецЕсли;

	ПутьКФайлуШаблонаCI = ОбъединитьПути(КаталогПриложения, "tools", "CI", ".gitlab-ci.yml");
	ПутьКФайлуCI 		= ОбъединитьПути(РабочийКаталог, ".gitlab-ci.yml");

	ЧтениеТекста = Новый ЧтениеТекста(ПутьКФайлуШаблонаCI, КодировкаТекста.UTF8);
	ТекстФайла = ЧтениеТекста.Прочитать();
	ЧтениеТекста.Закрыть();

	ПарсерYAML = Новый ПарсерYAML;
	РезультатЧтения = ПарсерYAML.ПрочитатьYaml(ТекстФайла);

	МассивШагов = РезультатЧтения.Получить("stages");
	Если МассивШагов = Неопределено Тогда
		ТекстИсключения = СтрШаблон("Ошибка чтения файла шаблона pipeline по пути: %1", ПутьКФайлуШаблонаCI);
		Лог.Ошибка(ТекстИсключения);
		Возврат;
	КонецЕсли;

	КопироватьФайл(ПутьКФайлуШаблонаCI, ПутьКФайлуCI);
	ТекстСообщения = СтрШаблон("Файл настроек pipeline сохранен в %1", ПутьКФайлуCI);
	Лог.Информация(ТекстСообщения);

	Лог.Информация("Инициализация завершена");

КонецПроцедуры // ВыполнитьКоманду

#КонецОбласти

РабочийКаталог = ПараметрыПриложения.ТекущийКаталог();
КаталогПриложения = ПараметрыПриложения.КаталогПриложения();
